// AutomationClientDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AutomationClient.h"
#include "AutomationClientDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutomationClientDlg dialog

CAutomationClientDlg::CAutomationClientDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutomationClientDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutomationClientDlg)
	m_sText = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAutomationClientDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutomationClientDlg)
	DDX_Text(pDX, IDC_EDIT, m_sText);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAutomationClientDlg, CDialog)
	//{{AFX_MSG_MAP(CAutomationClientDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_COPY_TEXT, OnButtonCopyText)
	ON_BN_CLICKED(IDC_BUTTON_FIND, OnButtonFind)
	ON_BN_CLICKED(IDC_BUTTON_APPEND_MENU, OnButtonAppendMenu)
	ON_BN_CLICKED(IDC_BUTTON_AUTOMATE, OnButtonAutomate)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutomationClientDlg message handlers

BOOL CAutomationClientDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	SetPreAutomationState();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAutomationClientDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAutomationClientDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAutomationClientDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAutomationClientDlg::OnCancel() 
{
	CoUninitialize();		// uninitialize COM
	
	CDialog::OnCancel();
}



//
// Set dialog controls to "pre-automation" state
//
void CAutomationClientDlg::SetPreAutomationState()
{
	GetDlgItem(IDC_BUTTON_AUTOMATE)->EnableWindow();
	GetDlgItem(IDC_BUTTON_APPEND_MENU)->EnableWindow( FALSE );
	GetDlgItem(IDC_BUTTON_FIND)->EnableWindow( FALSE );
	GetDlgItem(IDC_BUTTON_COPY_TEXT)->EnableWindow( FALSE );
}


//
// Set dialog controls to "automated" state
//
void CAutomationClientDlg::SetPostAutomationState()
{
	GetDlgItem(IDC_BUTTON_AUTOMATE)->EnableWindow( FALSE );
	GetDlgItem(IDC_BUTTON_APPEND_MENU)->EnableWindow();
	GetDlgItem(IDC_BUTTON_FIND)->EnableWindow();
	GetDlgItem(IDC_BUTTON_COPY_TEXT)->EnableWindow();
}



//////////////////////////////////////////////////////////////////////////////////////
//
// Specific includes and buttons handlers  
//

// Import type library for IHandlerPtr
#include "ImportNotepadHandlerTlb.h"

#include "ObjectROTToken.h"
#include "GetObjectFromROT.h"


const char g_szLoader[] =	// Loader application
#ifdef _DEBUG
	_T("LoaderD.exe");
#else
	_T("Loader.exe");
#endif


//
// Get proxy of the COM object embedded to target process 
//
IHandlerPtr GetObject()
{	
	IHandlerPtr spHandler = NULL;
	HRESULT hr = GetObjectFromROT<IHandler>( (LPTSTR)g_szROTRegToken, &spHandler );
	return SUCCEEDED(hr) ? spHandler : NULL;
}


//
// Copy Text button handler
//
void CAutomationClientDlg::OnButtonCopyText() 
{
	IHandlerPtr spHandler = GetObject();
	
	if ( NULL != spHandler )
	{
		BSTR bsText;
		spHandler->GetLastTypedCharSequence( &bsText );
		_bstr_t bstText( bsText, FALSE );

		m_sText = bsText;
		UpdateData( FALSE );
	}
	else
		SetPreAutomationState();
}


//
// Find button handler
//
void CAutomationClientDlg::OnButtonFind() 
{
	const int IDM_NOTEPAD_FIND = 3;
	IHandlerPtr spHandler = GetObject();

	if ( NULL != spHandler )
		spHandler->DoMenuCommand( IDM_NOTEPAD_FIND );
	else
		SetPreAutomationState();
}


//
// Append Menu button handler
//
void CAutomationClientDlg::OnButtonAppendMenu() 
{
	IHandlerPtr spHandler = GetObject();

	if ( NULL != spHandler )
		spHandler->AppendMenu();
	else
		SetPreAutomationState();
}


//
// Automate Notepad button handler
//
void CAutomationClientDlg::OnButtonAutomate() 
{
	// Execute Loader application to run target application and 
	//		inject DLL to target process
	WinExec( g_szLoader, SW_HIDE );

	if ( SUCCEEDED(CoInitialize(NULL)) )	// initialize COM
		SetPostAutomationState();
}


