// GetObjectFromROT.h

//
// Get proxy of the COM object embedded to target process 
//
template <class I>
HRESULT GetObjectFromROT(TCHAR* szROTRegToken, I** pp)
{
	if  ( NULL != *pp )
		return E_POINTER;

	IUnknownPtr spUnk = NULL;
    IRunningObjectTablePtr spTable;
	HRESULT hr = GetRunningObjectTable( 0, &spTable );

	IEnumMonikerPtr spEnum = NULL;
	if ( SUCCEEDED(hr) )
		hr = spTable->EnumRunning( &spEnum );
	
	if ( SUCCEEDED(hr) )
	{
		const _bstr_t bsROTRegToken( szROTRegToken );
		_bstr_t bsCurToken; 

		IMonikerPtr spMoniker = NULL;
		while ( SUCCEEDED(spEnum->Next(1, &spMoniker, NULL)) && NULL != spMoniker ) 
		{
			IBindCtxPtr spContext = NULL;
			hr = CreateBindCtx( 0, &spContext );

			if ( SUCCEEDED(hr) )
			{
				WCHAR* wsCurToken = NULL;
				hr = spMoniker->GetDisplayName( spContext, NULL, &wsCurToken );
				bsCurToken = wsCurToken; 
				if ( SUCCEEDED(hr) && bsROTRegToken == bsCurToken )
				{
					hr = spTable->GetObject( spMoniker, &spUnk );
					break;
				}						
			}

			spMoniker.Release();
		}
	}

	if ( SUCCEEDED(hr) && NULL != spUnk )
		hr = spUnk->QueryInterface( __uuidof(I), (void**)pp );

	return hr;
}

