// Handler.h : Declaration of the CHandler

#ifndef __HANDLER_H_
#define __HANDLER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CHandler
class ATL_NO_VTABLE CHandler : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHandler, &CLSID_Handler>,
	public IDispatchImpl<IHandler, &IID_IHandler, &LIBID_NOTEPADHANDLERLib>
{
public:
	CHandler() : m_dwRotId(0), m_hWnd(0)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_HANDLER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CHandler)
	COM_INTERFACE_ENTRY(IHandler)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

public:
// IHandler
	STDMETHOD(RegisterWithROT)();
	STDMETHOD(UnregisterWithROT)();
	STDMETHOD(SetWnd)(/*[in]*/ DWORD dwWnd);
	STDMETHOD(SetText)(/*[in]*/ BSTR bsText);
	STDMETHOD(GetLastTypedCharSequence)(/*[out]*/ BSTR* pbsText);
	STDMETHOD(DoMenuCommand)(/*[in]*/ DWORD dwMenuId);
	STDMETHOD(AppendMenu)();

private:
	DWORD    m_dwRotId; // object's ROT registration ID
	HWND     m_hWnd;	// handle of target application's frame window 
	CComBSTR m_bsBuf;	// inserted text buffer
};

#endif //__HANDLER_H_
